

//package Aufgabe;

import java.util.ArrayList;
import java.util.List;
import java.lang.reflect.Array;
import java.lang.Integer;
import java.lang.Boolean;

/** Aufgabentyp1:
  * Nach Vorgabe zufällig ermittelter Zeitpunkte und dort
  * eingetretenen Aktionen soll das Congestion Window am
  * Ende eines vorgegebenen Bereiches bestimmt werden. Der
  * Schwellenwert ssthresh wird mit 64 initialisiert.
  * Beispiel: Nach x Runden kommt es während einer TCP-Übertragung
  * zu einem Paketverlust, der mittels TDACK entdeckt wird. Nach
  * y Runden kommt es zu einem Timeout. Wie groß ist das Congestion
  * Window nach z Runden? */
public class Aufgabentyp1 extends Aufgabe
{

	public Aufgabentyp1(int bereichx, int anzahl)
	{
		super(bereichx, anzahl);
	}

	/** Erzeugt den Aufgabentext und gibt ihn an die Klasse Aufgabentrainer zurück */
	public String createAufgabe()
	{
		String anzeigetext ="";
		// Erstelle Aufgabentext
		for (int i=0; i<Array.getLength(aktionen); i++)
		{
			anzeigetext = anzeigetext + "Nach "+Integer.toString(aktionen[i][0])+" Runden kommt es zu einem ";
			if (aktionen[i][1] == Timeout)
				anzeigetext = anzeigetext + "Timeout. \n";
			else
				anzeigetext = anzeigetext + "TDACK. \n";
		}
		anzeigetext = anzeigetext + "Wie groß ist das Congestion Window nach "+Integer.toString(bereichx)+" Runden?\n";
		anzeigetext = anzeigetext + "Wie groß ist ssthresh nach "+Integer.toString(bereichx)+" Runden?\n";
		return anzeigetext;

	}

	/** Erhält alle Benutzerspezifischen Daten zur späteren Abspeicherung und Auswertung.
	  * Dies sind beispielsweise Benutzername, Passwort, benötigte Zeit für die Aufgabe,
	  * Ergebnis der Aufgabe und Schwierigkeitsgrad */
	public void send(List SendParameter)
	{
		for (int i=0; i<SendParameter.size(); i++)
		{
			System.out.println(SendParameter.get(i));
		}
		results k1 = new results();
		k1.command ="ergeing";
		//k1.appletid =(String)SendParameter.get(6);
		k1.id =(String)SendParameter.get(4);
		k1.password=(String)SendParameter.get(5);
		k1.difficulty=Integer.toString(Integer.parseInt((String)SendParameter.get(3))*Integer.parseInt((String)SendParameter.get(2)));

		if (SendParameter.get(1).equals("false"))
			k1.valuation = "+1";
		else
			k1.valuation = "-1";

		k1.time =(String)SendParameter.get(0);
		k1.status();

		k1.destip ="192.168.17.50";
		k1.destport = 3200;
		k1.send();
	    k1.status();

	}

	public void save(){};

	/** Kontrolliert die Benutzereingaben auf Richtigkeit */
	public boolean doCheck(List controls)
	{
		Object [] controlwerte = controls.toArray();
		// Gehe durch alle Controls und lese Werte aus.
		// erste Eingabe: Ergebnis des Benutzers für die Größe
		// des Congestion Windows
		int cwnduser = Integer.parseInt((String)controlwerte[0]);
		// zweite Eingabe: Ergebnis des Benutzers für die Größe
		// von ssthresh
		int ssthreshuser = Integer.parseInt((String)controlwerte[1]);
		// tatsächlicher Wert des Congestion Windows zum Zeitpunkt bereichx
		int cwnd = getCongestionWindowResult(bereichx);
		if ((cwnd == cwnduser) && (ssthresh==ssthreshuser))
			return true;
		else
			return false;
	};


	public int[] getErgebnis()
	{
		int [] ergebnis = {cwndergebnis, ssthresh};
		return ergebnis;
	}



}