import java.util.ArrayList;
import java.util.List;
import java.lang.reflect.Array;


/** Aufgabentyp2:
  * Nach Vorgabe zufällig ermittelter Zeitpunkte und dort
  * eingetretenen Aktionen wird dem Benutzer der Verlauf des
  * Congestion Window angezeigt. Der Schwellenwert ssthresh wurde
  * mit 64 initialisiert. Der Benutzer soll nun angeben, in welchen
  * Zeitpunkten welche Aktionen aufgetreten sind. */
public class Aufgabentyp2 extends Aufgabe {

	public Aufgabentyp2(int bereichx, int anzahl)
	{
		super(bereichx, anzahl);
	}


	/** Erhält alle Benutzerspezifischen Daten zur späteren Abspeicherung und Auswertung.
	  * Dies sind beispielsweise Benutzername, Passwort, benötigte Zeit für die Aufgabe,
	  * Ergebnis der Aufgabe und Schwierigkeitsgrad */
	public void send(List SendParameter)
	{
		for (int i=0; i<SendParameter.size(); i++)
		{
			System.out.println(SendParameter.get(i));
		}
		results k1 = new results();
				k1.command ="ergeing";
				k1.appletid =(String)SendParameter.get(6);
				k1.id =(String)SendParameter.get(4);
				k1.password=(String)SendParameter.get(5);
				k1.difficulty=Integer.toString(Integer.parseInt((String)SendParameter.get(3))*Integer.parseInt((String)SendParameter.get(2)));

				if (SendParameter.get(1).equals("false"))
					k1.valuation = "+1";
				else
					k1.valuation = "-1";

				k1.time =(String)SendParameter.get(0);
				k1.status();

				k1.destip ="192.168.17.50";
				k1.destport = 3200;
				k1.send();
	    k1.status();
	}

	public void save(){};


	public List getErgebnis()
	{
		List ergebnis = new ArrayList();
		for (int i=0; i<Array.getLength(aktionen); i++)
		{
			ergebnis.add(Integer.toString(aktionen[i][0]));
			ergebnis.add(Integer.toString(aktionen[i][1]));
		}
		ergebnis.add(Integer.toString(ssthresh));
		return ergebnis;
	}

	/** Kontrolliert die Benutzereingaben auf Richtigkeit */
	public boolean doCheck(List controls)
		{
			int j=0;
			Object [] controlwerte;
			// Gehe durch alle Controls und lese Werte aus.
			controlwerte = controls.toArray();
			// Eingegeben jeweils Aktionszeitpunkt und Aktion
			// Gehe alle durch und vergleiche sie mit den
			// Einträgen in aktionen[][]
			// letzter Eintrag ist ssthresh
			if (Integer.parseInt((String)controlwerte[controls.size()-1]) != ssthresh)
				return false;
			// erster Eintrag: Anzahl der Aktionen
			for (int i=0 ;i<Array.getLength(aktionen); i++)
				{
					System.out.println("for: "+controlwerte[j]+","+controlwerte[j+1]);
					// Zeitpunkte richtig angegeben?
					if (aktionen[i][0] != Integer.parseInt((String)controlwerte[j]))
						return false;
					// Aktionen richtig angegeben?
					if (aktionen[i][1] != Integer.parseInt((String)controlwerte[j+1]))
						return false;
					j+=2;
				}
			return true;
	}

	/** Erzeugt den Aufgabentext und gibt ihn an die Klasse Aufgabentrainer zurück */
	public int[] createAufgabe()
	{

		int cwndneu=1;
		int cwndalt=1;
		int j;
		int[] ergebnis = new int[bereichx];

		// bestimme für alle x von 1 bis bereichx
		// die zugehörigen CongestionWindow Größen und speichere sie in
		// einem Array ab. Dieses wird dann in Aufgabentrainer als
		// Funktion dargestellt werden.
		for (int i=0; i<bereichx; i++)
		{
			// wenn x enthalten in Array Aktionen, hat eine Aktion
			// stattgefunden -> Timeout oder TDACK
			j=inArray(aktionen, i);
			if (j >= 0)
			{
				// Eintrag in aktionen gibt Art der Aktion an.
				if (aktionen[j][1] == Timeout)
				  // wenn Aktion = Timeout -> vTimeout true, vTDACK false
				  cwndneu = (int)getCongestionWindow(cwndalt,false,true);
				else
				  // sonst Aktion = TDACK -> vTDACK true, vTimeout false
				  cwndneu = (int)getCongestionWindow(cwndalt,true,false);
			 }
			 else
				// kein Aktionszeitpunkt, also nichts passiert
				// damit vTimeout false, vTDACK false
				cwndneu = (int)getCongestionWindow(cwndalt, false,false);
			cwndalt=cwndneu;
			ergebnis[i]=cwndalt;
			}
		return ergebnis;
	}

}