//package Aufgabe;


import java.awt.Graphics;
import java.awt.Panel;
import java.awt.Color;
import java.awt.Font;
import java.lang.reflect.Array;
import java.util.Map;
import java.util.HashMap;
import java.util.Set;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import javax.swing.JComponent;

public class DrawGrafik2 extends JComponent
{
	int [] xPoints;
	int [] werte;
	int anzahl;

	public DrawGrafik2(int[] xPoints, int[] werte, int anzahl)
	{
		// Darstellen der Kurve der übergebenen x-Werte und y-Werte
		this.xPoints=xPoints;
		this.werte=werte;
		this.anzahl=anzahl;
	}

	public DrawGrafik2(List ywerte)
	{
		anzahl = ywerte.size();

		// Darstellen der übergebenen Liste von y-Werten
		xPoints = new int [anzahl];

		werte = new int [anzahl];
		for (int i=0; i< anzahl; i++)
		{
			xPoints[i] = i+1;
			Integer y = (Integer) ywerte.get(i);
			werte[i] = y.intValue();
		}
	}

	private int [] skalierung(int[] x, String art)
	{
		int anzahl = Array.getLength(x);
		int [] i = new int[anzahl];
		int maxvalue = 0;
		int maxhoehe = getSize().height;

		// maximalen y-Wert zur späteren Skallierung der y-Werte
		// feststellen.
		for (int z=0; z<anzahl; z++)
		{
			if (x[z] > maxvalue)
				maxvalue = x[z];
		}

		// Saklierung der Werte
		for (int j=0; j<anzahl; j++)
		{
			// wenn x-Achse skaliert werden soll, Bezug auf
			// Breite der zur Verfügung stehenden Komponente
			if (art.equals("x"))
				i[j]=(int) ((x[j]-1)*(getSize().width-10)/anzahl)+10;
			// Bei Skalierung der y-Achse Bezug auf Höhe der Komponente
			// sowie auf maximalen y-Wert
			else
				i[j]=(int) (getSize().height-x[j]*((getSize().height-100)/(maxvalue+20)))-100;
		}
		return i;
	}


	public void paint(Graphics g)
	{
		int t=0;
		int xpos=10;
		int ypos=getSize().height-80;
		this.setOpaque(false);
		g.setColor(Color.blue);

		Map wertepaare = new HashMap();
		// Werte passend auf Panelgröße transformieren
		int [] xwerte = skalierung(xPoints, "x");
		int [] ywerte = skalierung(werte, "y");
		// Linien zeichnen
		g.drawPolyline(xwerte, ywerte, anzahl);
		g.setColor(Color.black);
		this.setOpaque(false);
		g.drawLine(10,0,10, getSize().height-100);
		g.drawLine(10,getSize().height-100,getSize().width, getSize().height-100);
		// spezielle Punkte, für die Wertepaare festgehalten werden, einzeichnen.
		// Wertepaare zu punkten in HashMap festhalten
		for (int i=0; i<Array.getLength(werte); i++)
		{
			// Beginn von Congestion Avoidence
			if ((i != 0) && (i != (Array.getLength(werte)-1)) && (werte[i+1] == (werte[i]+1)) && (werte[i-1] != (werte[i]-1)) && (werte[i+1] != 2))
			{
				if (wertepaare.containsKey(new Integer(xPoints[i])) == false)
					wertepaare.put(new Integer(xPoints[i]),new Integer(werte[i]));
				g.fillRect(xwerte[i], ywerte[i],3,3);
			}
			// Timeout
			if ((i != 0) && (werte[i] == 1))
			{
				if (wertepaare.containsKey(new Integer(xPoints[i])) == false)
					wertepaare.put(new Integer(xPoints[i]),new Integer(werte[i]));
				if (wertepaare.containsKey(new Integer(xPoints[i-1])) == false)
					wertepaare.put(new Integer(xPoints[i-1]),new Integer(werte[i-1]));
				g.fillRect(xwerte[i-1], ywerte[i-1],3,3);
				g.fillRect(xwerte[i], ywerte[i],3,3);
			}
			// TDACK
			if ((i != 0) && ((int)(werte[i-1]/2) == werte[i]) )
			{
				if (wertepaare.containsKey(new Integer(xPoints[i])) == false)
					wertepaare.put(new Integer(xPoints[i]),new Integer(werte[i]));
				if (wertepaare.containsKey(new Integer(xPoints[i-1])) == false)
					wertepaare.put(new Integer(xPoints[i-1]),new Integer(werte[i-1]));
				g.fillRect(xwerte[i-1], ywerte[i-1],3,3);
				g.fillRect(xwerte[i], ywerte[i],3,3);
			}

		}
		g.setColor(Color.lightGray);
		g.setFont(new Font("Serif", Font.ITALIC+Font.BOLD, 16));
		// Wertepaare zu festgehaltenen Punkten ausgeben.
		g.drawString("spezielle Wertepaare: ",xpos,ypos);
		ypos = ypos + 15;
		int zaehler = 0;
		for (int i=0; i< Array.getLength(ywerte); i++)
		{
			if (wertepaare.containsKey(new Integer(i)) == true)
			{
				xpos = xpos + getSize().width/4;
				if ((zaehler% 4) == 0)
				{
					ypos += 15;
					xpos = 10;
				}
				zaehler++;
				g.drawString("("+Integer.toString(i)+","+wertepaare.get(new Integer(i))+")",xpos,ypos);
			}
		}

	}
}